<?php
/**********************************************************************************
* BadBehavior-SMF.php - PHP template for Bad Behavior mod
* Version 1.5.21 by JMiller a/k/a butchs
* (http://www.eastcoastrollingthunder.com) 
*********************************************************************************
* This program is distributed in the hope that it is and will be useful, but
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
**********************************************************************************/

###############################################################################
###############################################################################
if (!defined('SMF')) die('Hacking attempt...');

$bb2_mtime = explode(" ", microtime());
$bb2_timer_start = $bb2_mtime[1] + $bb2_mtime[0];

define('BB2_CWD', dirname(__FILE__));

	global $bb2_settings_defaults, $badbehavior_settings, $context, $boardurl;
	global $db_prefix, $smcFunc, $sourcedir, $modSettings, $webmaster_email;
	global $user_info, $language, $user_settings;

// Bad Behavior callback functions.
require_once($sourcedir . '/BadBehavior-mysql.php');

// Settings you can adjust for Bad Behavior.
$bb2_settings_defaults = array();
$badbehavior_settings = array();

// Return current timestamp in the format preferred by your database.
function bb2_db_date() {
	return date('Y-m-d H:i:s');	// Example is MySQL format good for SMF
}

// Return affected rows from most recent query.
function bb2_db_affected_rows() {
	global $smcFunc;

	return $smcFunc['db_affected_rows']();
}

// Escape a string for database usage
function bb2_db_escape($string) {
//	Not required for SMF 2.0+
 return $string;
}

// Return the number of rows in a particular query.
function bb2_db_num_rows($link) {
	global $smcFunc;
	return $smcFunc['db_num_rows']($link);
}

function badbehavior_db_errortrap($errno, $string) {
	log_error($errno . ' ' . $string, 'user');
}

// Run a query and return the results, if any.
// Should return FALSE if an error occurred.
// Bad Behavior will use the return value here in other callbacks.
function bb2_db_query($query) {
	global $smcFunc;

	if (empty($query))  //  This really is not a query
		return;

	$link = $smcFunc['db_query']($query);

	if (!$link) { //If it's 0/FALSE then there was some kind of error
		return false; //Return false if there is an error
  	}
	if ($link === TRUE) { //If it's exactly TRUE then it was a succesful WRITE operation
		$affected_rows = bb2_db_affected_rows(); //how many affected rows in a WRITE query?
		if ($affected_rows >= 1) {
			return true; //Something was succesfully written
		} else {
		return false; //Nothing was written
		}  
	} else { //If it's not 0/FALSE and it's not exactly TRUE then it was a READ operation
		$number_of_rows = bb2_db_num_rows($link); //number of rows read the READ query?
		if ($number_of_rows == '0') {
			return false; //No rows were found for query
		}
	}

	$result = bb2_db_rows($link); //Go get all the rows and put them an array

	return $result;
}

function badbehavior_checkCache($ip2) {

	if ($ip2 == '') return false;

	$cache_content = $stamp = $bb_salt = '';
	$stamp = date('Ymd');
	$bb_salt = 'J#c3';

	if (function_exists('hash')) {
		if ($stamp  % 2) {
			$badbehavior_algo = 'tiger160,4';
		} else {
			$badbehavior_algo = 'haval192,4'; }
		$cache_content = badbehavior_cache_get_data('badbehavior-' . substr(hash($badbehavior_algo,$bb_salt.$stamp.$ip2), -8), 0);
	} else {
		$cache_content = badbehavior_cache_get_data('badbehavior-' . substr(md5($bb_salt.$stamp.$ip2), -8), 0); } 

	if (empty($cache_content))  {
		unset($cache_content,$stamp,$bb_salt);
       	return false; }
	unset($cache_content,$stamp,$bb_salt);
return true;
}

function badbehavior_loadCache($ip2, $badbehavior_cache_array) {

	global $modSettings;

	if ($ip2 == '') return;
	if (empty($badbehavior_cache_array)) return;
	if (!is_array($badbehavior_cache_array)) return;

	// default 0 seconds
	$cache_content = $badbehavior_expire = $stamp = $bb_salt = '';
	$badbehavior_expire = 0;
	$stamp = date('Ymd');
	$bb_salt = 'J#c3';

	foreach($badbehavior_cache_array as $key => $value) {
		$cache_content .= $value; }
		unset($value);
	if (is_int((int) $modSettings['badbehavior_cache_duration']))
		$badbehavior_expire = ((int) $modSettings['badbehavior_cache_duration']);
	if (function_exists('hash')) {
		if ($stamp  % 2) {
			$badbehavior_algo = 'tiger160,4';
		} else {
			$badbehavior_algo = 'haval192,4'; }
		badbehavior_cache_put_data('badbehavior-' . substr(hash($badbehavior_algo,$bb_salt.$stamp.$ip2), -8), $cache_content, $badbehavior_expire);
	} else {
		badbehavior_cache_put_data('badbehavior-' . substr(md5($bb_salt.$stamp.$ip2), -8), $cache_content, $badbehavior_expire); } 
	unset($badbehavior_expire, $cache_content, $stamp, $bb_salt);
	return;
}

function badbehavior_cache_put_data($key, $value, $ttl = 0)
{
	global $modSettings, $cache_hits, $cache_count, $db_show_debug, $cachedir;

	if (((int) $modSettings['badbehavior_cache_duration']) == 0) return;

	$cache_count = isset($cache_count) ? $cache_count + 1 : 1;
	if (isset($db_show_debug) && $db_show_debug === true)
	{
		$cache_hits[$cache_count] = array('k' => $key, 'd' => 'put', 's' => $value === null ? 0 : strlen(serialize($value)));
		$st = microtime();
	}

	$value = empty($value) ? null : serialize($value);
	$bb_filename = '';
	$bb_filename = $cachedir . DIRECTORY_SEPARATOR . 'data_' . $key . '.php';

	if (function_exists('fwrite')) {
		if ($value === null)
			@unlink($bb_filename);
		else {
			$cache_data = '';
 			$cache_data = '<' . '?' . 'php if (!defined(\'SMF\')) die; $bballotted = \'' . (time() + $ttl) . '\'; $value = \'' . addcslashes($value, '\\\'') . '\'; ' . '?' . '>';

			// Write out the cache file, check that the cache write was successful; all the data must be written
			// If it fails due to low diskspace, or other, remove the cache file
			if (file_put_contents($bb_filename, $cache_data, LOCK_EX) !== strlen($cache_data))
				@unlink($bb_filename);
	}	}

	if (isset($db_show_debug) && $db_show_debug === true)
		$cache_hits[$cache_count]['t'] = array_sum(explode(' ', microtime())) - array_sum(explode(' ', $st));

	return;
}

function badbehavior_cache_get_data($key, $ttl = 0) {
	global $modSettings, $cache_hits, $cache_count, $db_show_debug, $cachedir;

	if (((int) $modSettings['badbehavior_cache_duration']) == 0) return null;

	$expired = true;
	$cache_count = isset($cache_count) ? $cache_count + 1 : 1;
	if (isset($db_show_debug) && $db_show_debug === true) {
		$cache_hits[$cache_count] = array('k' => $key, 'd' => 'get');
		$st = microtime();
	}
	$bb_filename ='';
	$bb_filename = $cachedir . DIRECTORY_SEPARATOR . 'data_' . $key . '.php';

	// My cache!
	if (is_file($bb_filename) && is_readable($bb_filename) && filesize($bb_filename) > 10) {
		@include($bb_filename);

		if (!isset($bballotted) || empty($bballotted)) $bballotted = 0;
		if((int)$bballotted > time())
			$expired = false;

		$bballotted = null;

		if ((bool)$expired !== false && isset($value)) {
			@unlink($bb_filename);
			unset($value);

	}	}

	if (isset($db_show_debug) && $db_show_debug === true) {
		$cache_hits[$cache_count]['t'] = array_sum(explode(' ', microtime())) - array_sum(explode(' ', $st));
		$cache_hits[$cache_count]['s'] = isset($value) ? strlen($value) : 0;
	}

	if (empty($value))
		return null;
	// If it's broke, it's broke... so give up on it.
	else
		return @unserialize($value);
}

// Return all rows in a particular query.
// Should contain an array of all rows generated by calling mysql_fetch_assoc()
// or equivalent and appending the result of each call to an array.
function bb2_db_rows($linkid) {
	global $smcFunc;

	if (empty($linkid))
		return false;

	if (!is_array($linkid))
		return false;

	$result = array();
	$i = 0;

	while($row = $smcFunc['db_fetch_assoc']($linkid)) {
		$result[$i] = $row;
    	$i++;
	}

	if (empty($result))
		$result = $linkid; //If there were no rows, then just return the id

	$smcFunc['db_free_result']($linkid);

	return $result;
}

// Return emergency contact email address.
function bb2_email() {
	global $webmaster_email;

	$target_email = '';

	if ((!isset($webmaster_email)) || ($webmaster_email == ''))
		return '';

	return $webmaster_email;
}

function bb2_email_scramble() {
	global $webmaster_email;

	$target_email = '';

	if ((!isset($webmaster_email)) || ($webmaster_email == ''))
		$webmaster_email = "badbots@ioerror.us";

	$target_email = badbehavior_obfuscate(htmlspecialchars($webmaster_email));

	return $target_email;
}

function badbehavior_obfuscate($target_email) {
	global $txt, $sourcedir;

	if (function_exists('loadlanguage')) {
		if(loadlanguage('BadBehavior') === false)
     		 loadLanguage('BadBehavior');
	} else {
		require_once($sourcedir . '/Load.php');
		if(loadlanguage('BadBehavior') === false)
      		loadLanguage('BadBehavior'); }

	$stamp = date('Ymd');
	$webmaster_nospam  = $email = $encoding = $x = '';
	$search = array('@','.', '-');
	$replace = array($txt['badbehavior_nospam'], $txt['badbehavior_dot'], $txt['badbehavior_dash']);
	$characters = array('0000','0','0000','00000','000','00000','00','000', '00', '0');

	$webmaster_nospam = $txt['badbehavior_mailto'].str_replace($search, $replace, htmlspecialchars($target_email));

	list($usec, $sec) = explode(' ', microtime());
	mt_srand((float) $sec + ((float) $usec * 100000));
	$x = mt_rand(0, (count($characters)-1));
	$encoding = $characters[$x];

	if ($stamp  % 2) {
		for ($i = 0, $email_lng = strlen($webmaster_nospam); $i < $email_lng; $i++) {
			$email .= '&#x' .$encoding . dechex(ord($webmaster_nospam[$i])). ';'; }

 	} else {
		for ($i = 0, $email_lng = strlen($webmaster_nospam); $i < $email_lng; $i++) {
			$email .= '&#' . $encoding . ord($webmaster_nospam[$i]). ';'; }
	}
	$webmaster_nospam = $email;

	unset($email_lng, $i, $x, $email);
	unset($search, $replace, $characters);

	return $webmaster_nospam ;
}

function bb2_email_to() {
	global $txt, $sourcedir;

	if (function_exists('loadlanguage')) {
		if(loadlanguage('BadBehavior') === false)
     		 loadLanguage('BadBehavior');
	} else {
		require_once($sourcedir . '/Load.php');
		if(loadlanguage('BadBehavior') === false)
      		loadLanguage('BadBehavior'); }

	return $txt['badbehavior_theadmin'];
}

// retrieve whitelist from db- return parse_ini_string
function bb2_read_whitelist() {
	global $modSettings;

	if(!isset($modSettings['badbehavior_ip']) && !isset($modSettings['badbehavior_url']) && !isset($modSettings['badbehavior_useragent'])) return false;  //  Reject Bot scans

	return array_merge(
		Array("ip" => preg_split("/[\n\r]+/m", $modSettings['badbehavior_ip'], NULL, PREG_SPLIT_NO_EMPTY)),
		Array("url" => preg_split("/[\n\r]+/m", $modSettings['badbehavior_url'], NULL, PREG_SPLIT_NO_EMPTY)),
		Array("useragent" => preg_split("/[\n\r]+/m", $modSettings['badbehavior_useragent'], NULL, PREG_SPLIT_NO_EMPTY))
	);
}

// retrieve settings from database
// Settings are hard-coded for non-database use
function bb2_read_settings() {
	global $badbehavior_settings, $modSettings, $db_prefix;

	$badbehavior_settings['enable_badbehavior'] = $modSettings['enable_badbehavior'];
	$badbehavior_settings['log_table'] = $db_prefix . 'log_badbehavior';
	$badbehavior_settings['display_stats'] = $modSettings['badbehavior_display_stats'];
	$badbehavior_settings['strict'] = $modSettings['badbehavior_strict'];
	$badbehavior_settings['verbose'] = $modSettings['badbehavior_verbose'];
	$badbehavior_settings['logging'] = $modSettings['badbehavior_logging'];
	$badbehavior_settings['httpbl_key'] = $modSettings['badbehavior_httpbl_key'];
	$badbehavior_settings['httpbl_threat'] = $modSettings['badbehavior_httpbl_threat'];
	$badbehavior_settings['httpbl_maxage'] = $modSettings['badbehavior_httpbl_maxage'];
	$badbehavior_settings['offsite_forms'] = $modSettings['badbehavior_offsite_forms'];
	$badbehavior_settings['eu_cookie'] = $modSettings['badbehavior_eu_cookie'];
	$badbehavior_settings['reverse_proxy'] = $modSettings['badbehavior_reverse_proxy'];
	$badbehavior_settings['reverse_proxy_header'] = $modSettings['badbehavior_reverse_proxy_header'];

	if (isset($modSettings['badbehavior_reverse_proxy_addresses']) && !empty($modSettings['badbehavior_reverse_proxy_addresses'])) {
		//		$reverse_proxy_addresses = '';
		$badbehavior_settings['reverse_proxy_addresses'] = array();
		 
		$badbehavior_settings['reverse_proxy_addresses'] = preg_split("/[\n\r]+/m", $modSettings['badbehavior_reverse_proxy_addresses'], NULL, PREG_SPLIT_NO_EMPTY);  //  possibly /\s+/m'.
/*		foreach ($reverse_proxy_addresses as $reverse_proxy_addresses_chunk) {
			$badbehavior_settings['reverse_proxy_addresses'][] = explode('\n\r', trim($reverse_proxy_addresses_chunk));
		}
		unset($reverse_proxy_addresses_chunk); */
	} else {
		$badbehavior_settings['reverse_proxy_addresses'] = $modSettings['badbehavior_reverse_proxy_addresses'] = '';
	}

	return $badbehavior_settings;
}

//	Write settings to database
//  Settings are written in SMF admin panel, this code is here for future referance
//  and only contains the essentials for BB
function bb2_write_settings($badbehavior_settings) {
	global $txt, $modSettings, $db_prefix, $smcFunc;

	isAllowedTo('admin_forum');
	if (empty($badbehavior_settings)) return false;

	if (!is_array($badbehavior_settings)) return false;

	if (is_array($badbehavior_settings['reverse_proxy_addresses'])) {
		$reverse_proxy_addresses = '';
		foreach($badbehavior_settings['reverse_proxy_addresses'] as $key => $value) {
			$reverse_proxy_addresses .= $value . '\n\r'; }
		unset($value);
		$reverse_proxy_addresses = substr($reverse_proxy_addresses, 0, -4);
	} else {
		$reverse_proxy_addresses = $badbehavior_settings['reverse_proxy_addresses'];
	}

	$smcFunc['db_insert']('ignore',
		'{db_prefix}settings',
			array('variable' => 'string', 'value' => 'string',
			),
			array(
				array('enable_badbehavior', $badbehavior_settings['enable_badbehavior']),
				array('badbehavior_log_table', $badbehavior_settings['log_table']),
				array('badbehavior_display_stats', $badbehavior_settings['display_stats']),
				array('badbehavior_strict', $badbehavior_settings['strict']),
				array('badbehavior_verbose', $badbehavior_settings['verbose']),
				array('badbehavior_logging', $badbehavior_settings['logging']),
				array('badbehavior_httpbl_key', $badbehavior_settings['httpbl_key']),
				array('badbehavior_httpbl_threat', $badbehavior_settings['httpbl_threat']),
				array('badbehavior_httpbl_maxage', $badbehavior_settings['httpbl_maxage']),
				array('badbehavior_offsite_forms', $badbehavior_settings['offsite_forms']),
				array('badbehavior_eu_cookie', $badbehavior_settings['eu_cookie']),
				array('badbehavior_reverse_proxy', $badbehavior_settings['reverse_proxy']),
				array('badbehavior_reverse_proxy_header', $badbehavior_settings['reverse_proxy_header']),
				array('badbehavior_reverse_proxy_addresses', $reverse_proxy_addresses),
			),
			array('variable')
		);

	unset($reverse_proxy_addresses);
	return true;
}

// installation
function bb2_install() {
	global $badbehavior_settings, $modSettings;

	$badbehavior_settings = bb2_read_settings();
	if (!$badbehavior_settings['logging']) return;

	bb2_db_query(bb2_table_structure($badbehavior_settings['log_table']));
	return;
}

function badbehavior_checkGoodgroup($badbehavior_ip) {
	global $sourcedir, $context, $user_info, $smcFunc;

	if ($badbehavior_ip == '') return true;
	if (!function_exists('allowedTo')) require_once($sourcedir . '/Security.php');
	if (allowedTo('badbehavior_goodgroup')) return false;

	$badbehavior_goodgroup = array();
	$dos_cond = true;

	$qresult = $smcFunc['db_query']('', '
		SELECT id_group, permission, add_deny
		FROM {db_prefix}permissions
		WHERE permission = {string:search_permission}
			AND add_deny = {int:permission_state}',
		array(
			'search_permission' => 'badbehavior_goodgroup',
			'permission_state' => 1,
		)
	);

	if ($smcFunc['db_num_rows']($qresult) > 0) {
		while ($row = $smcFunc['db_fetch_assoc']($qresult)) {
			$badbehavior_goodgroup[$row['permission']] = $row['id_group'];
	}	}
	$smcFunc['db_free_result']($qresult);

	if (!empty($badbehavior_goodgroup)) {
		if (function_exists('loadIllegalPermissions')) {
			loadIllegalPermissions();
		} else {
			require_once($sourcedir . '/ManagePermissions.php');
			loadIllegalPermissions(); }
		foreach ($badbehavior_goodgroup as $perm => $group_id) {
			if ($user_info['groups']['0'] == $group_id) {
				$dos_cond = false;
				break; }
			if (!empty($context['illegal_permissions']) && in_array($perm, $context['illegal_permissions'])) {
				$dos_cond = true;
				break; }
			$qresult = $smcFunc['db_query']('', '
				SELECT
					id_group, member_ip, member_ip2, is_activated
				FROM {db_prefix}members
				WHERE member_ip = {string:ipofuser}
					OR member_ip2 = {string:ipofuser}',
				array(
					'ipofuser' => $badbehavior_ip,
				)
			);
			if ($smcFunc['db_num_rows']($qresult) > 0) {
				while ($row = $smcFunc['db_fetch_assoc']($qresult)) {
					if ($row['id_group'] == $group_id) {
						$dos_cond = false;
						if ($row['is_activated'] >= 10) $dos_cond = true;  //  is_banned
						break;
			}	}	}
	$smcFunc['db_free_result']($qresult); }
	unset($perm, $group_id); }

	unset($badbehavior_goodgroup);

	return $dos_cond;
}

// Screener
// Insert this into the <head> section of your HTML through a template call
// or whatever is appropriate. This is optional we'll fall back to cookies
// if you don't use it.
function bb2_insert_head() {
	global $bb2_timer_total, $bb2_javascript, $modSettings;
	$honeyLink = '';
	if ($modSettings['badbehavior_limitfirst'])
		$honeyLink = '<a href="'. $modSettings['badbehavior_httpbl_link'] .'"><span style="display:none !important;">'. $modSettings['badbehavior_httpbl_word'] .'</span></a>';
	else
		$honeyLink = BB_honeyLink(10);
	echo "\n\r<!-- Bad Behavior " . BB2_VERSION . " run time: " . number_format(1000 * $bb2_timer_total, 3) . " ms -->\n\r";
	echo $honeyLink;
	echo $bb2_javascript;
}

// Get the total amount of blocked spammers in x days
function bb2_insert_stats($force = false) {
	global $smcFunc, $modSettings, $badbehavior_settings;

	if (empty($force) && !$modSettings['enable_badbehavior']) return;

	$badbehavior_settings = bb2_read_settings();

	$blocked = $qresult = $total_result = $where = '';

	$where = "bb.id >= 0";
	$qresult = $smcFunc['db_query']('', '
			SELECT COUNT(*)
			FROM {db_prefix}log_badbehavior AS bb
			WHERE ' . $where,
			array(
			'selected_key' => '00000000',
			)
		);
	if ($smcFunc['db_num_rows']($qresult) > 0) {
		$smcFunc['db_free_result']($qresult);

		$where = "bb.key NOT LIKE {string:selected_key}";
		$total_result = $smcFunc['db_query']('', '
			SELECT COUNT(*)
			FROM {db_prefix}log_badbehavior AS bb
			WHERE ' . $where,
			array(
			'selected_key' => '00000000',
			)
		);
		list ($blocked) = $smcFunc['db_fetch_row']($total_result);
		$smcFunc['db_free_result']($total_result);
	} else {
		$smcFunc['db_free_result']($qresult);
	}

	if (!empty($blocked)) {
		$timelimit = 7;  //  default 7 days
		if ((int) $modSettings['badbehavior_timelimit'] > 0)
			$timelimit = (int) $modSettings['badbehavior_timelimit'];
		if (empty($force)) {
         echo '<p><a href="http://www.bad-behavior.ioerror.us/">Bad Behavior</a> has blocked <strong>'.$blocked.'</strong> access attempts in the last '.$timelimit.' days.</p>';
		} else {
			if(isset($_SESSION['BB2_RESULT'])) unset($_SESSION['BB2_RESULT']);
			return '<a href="http://www.bad-behavior.ioerror.us/">Bad Behavior</a> has blocked <strong>'.$blocked.'</strong> access attempts in the last '.$timelimit.' days.';
		}
	}
	if (@!empty($_SESSION['BB2_RESULT'])) {
		if (empty($force))
			echo '<br /><!-- Bad Behavior result was '.$_SESSION['BB2_RESULT'].' This request would have been blocked. --><br />';
		unset($_SESSION['BB2_RESULT']);
	}
}

//  Generate a honeylink
function BB_honeyLink($maxnum = 18)
{
	global $modSettings;

	if (empty($modSettings['badbehavior_httpbl_link'])) return '';
	if (empty($modSettings['badbehavior_httpbl_word'])) $modSettings['badbehavior_httpbl_word'] = 'login';
	if (empty($maxnum)) $maxnum = 18;

	mt_srand(bb2_make_seed());

	switch (mt_rand(0, $maxnum)) {
		case 0:
			return '<a href="'. $modSettings['badbehavior_httpbl_link'] .'"><!-- '. $modSettings['badbehavior_httpbl_word'] .' --></a>';
		case 1:
			return '<a href="'. $modSettings['badbehavior_httpbl_link'] .'"></a>';
		case 2:
			global $boardurl;
		return '<img src="'. $boardurl . '/Themes/default/images/'. 'blank.gif" usemap="#bbMap" alt="'. $modSettings['badbehavior_httpbl_word'] .'" border="0" width="1" height="0" /><map name="bbMap"><area shape="default" href="'. $modSettings['badbehavior_httpbl_link'] .'" /></map>';
		case 3:
			return '<!-- <a href="'. $modSettings['badbehavior_httpbl_link'] .'">'. $modSettings['badbehavior_httpbl_word'] .'</a> -->';
		case 4:
			global $boardurl;
			return '<a href="'. $modSettings['badbehavior_httpbl_link'] .'"><img src="'. $boardurl. '/Themes/default/images/'. 'blank.gif" alt="'. $modSettings['badbehavior_httpbl_word'] .'" border="0" height="0" width="1" /></a>';
		case 5:
			return '<a href="'. $modSettings['badbehavior_httpbl_link'] .'">&#160</a>';
		case 6:
			return '<div style="position: absolute; top: -490px; left: -390px;"><a href="'. $modSettings['badbehavior_httpbl_link'] .'">'. $modSettings['badbehavior_httpbl_word'] .'</a></div>';
		case 7:
			return '<a href="'. $modSettings['badbehavior_httpbl_link'] .'"><font style="font-family: Arial;"></font></a>';
		case 8:
			return '<a href="'. $modSettings['badbehavior_httpbl_link'] .'">&#x00A0</a>';
		case 9:
			return '<span style="position:absolute;top:-220px;left:-220px;"><a href="'. $modSettings['badbehavior_httpbl_link'] .'">'. $modSettings['badbehavior_httpbl_word'] .'</a></span>';
		case 10:
			return '<a href="'. $modSettings['badbehavior_httpbl_link'] .'"><img src="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==" alt="'. $modSettings['badbehavior_httpbl_word'] .'" border="0" height="0" width="1" /></a>';
		case 11:
			return '<a style="cursor: text; text-decoration: none;" href="'. $modSettings['badbehavior_httpbl_link'] .'">&nbsp;</a>';
		case 12:
			return '<a href="'. $modSettings['badbehavior_httpbl_link'] .'"><div style="height: 0px; width: 0px;"></div></a>';
		case 13:
			return '<a href="'. $modSettings['badbehavior_httpbl_link'] .'" style ="color: #fff;">'. $modSettings['badbehavior_httpbl_word'] .'</a>';
		case 14:
			return '<a href="'. $modSettings['badbehavior_httpbl_link'] .'" style ="visibility: hidden; height: 0px; width: 0px;">'. $modSettings['badbehavior_httpbl_word'] .'</a>';
		case 15:
			return '<a href="'. $modSettings['badbehavior_httpbl_link'] .'"><span style="display: none !important;">'. $modSettings['badbehavior_httpbl_word'] .'</span></a>';
		case 16:
			return '<img src="'. $modSettings['badbehavior_httpbl_link'] .'" alt="'. $modSettings['badbehavior_httpbl_word'] .'" width="0" height="0" />';
		case 17:
			return '<a href="'. $modSettings['badbehavior_httpbl_link'] .'" style="display: none;">'. $modSettings['badbehavior_httpbl_word'] .'</a>';
		case 18:
			return '<div style="display: none;"><a href="'. $modSettings['badbehavior_httpbl_link'] .'">'. $modSettings['badbehavior_httpbl_word'] .'</a></div>';
		default:
			return '<!-- <a href="'. $modSettings['badbehavior_httpbl_link'] .'">'. $modSettings['badbehavior_httpbl_word'] .'</a> -->';
	}
}

//  Random seed for honeylink
function bb2_make_seed() {
  list($usec, $sec) = explode(' ', microtime());
  return (float) $sec + ((float) $usec * 100000);
}

// Return the top-level relative path of wherever we are (for cookies)
// You should provide in $url the top-level URL for your site.
function bb2_relative_path() {
global $boardurl;
	return $boardurl;
}

if ($user_info['is_admin'])
	require_once($sourcedir . '/BadBehavior-Admin.php');

// Calls inward to Bad Behavor itself.
require_once($sourcedir . '/bad-behavior/bad-behavior/core.inc.php');

//bb2_install();	// I do not think I need thnis - see above
if (($modSettings['enable_badbehavior']) && (!$user_info['is_admin']))
	$_SESSION['BB2_RESULT'] = bb2_start(bb2_read_settings());

$bb2_mtime = explode(" ", microtime());
$bb2_timer_stop = $bb2_mtime[1] + $bb2_mtime[0];
$bb2_timer_total = $bb2_timer_stop - $bb2_timer_start;

?>