<?php
/**********************************************************************************
* BadBehavior-Admin.php - for SMF 1.1.x - PHP template for Bad Behavior mod
* Version 1.5.16 by JMiller a/k/a butchs
* (http://www.eastcoastrollingthunder.com) 
*********************************************************************************
* This program is distributed in the hope that it is and will be useful, but
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
**********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

	global $bb2_settings_defaults, $context, $boardurl, $modSettings, $webmaster_email;
	global $db_prefix, $sourcedir, $settings, $badbehavior_settings;


// Admin initializer
function badbehavior_admin_init($return_config = false)
{
	isAllowedTo('admin_forum');
	global $txt, $scripturl, $context, $settings, $modSettings;
	global $sourcedir;

	if (loadlanguage('BadBehavior') === false)
		loadLanguage('BadBehavior');

	adminIndex('badbehavior');
	loadLanguage('Help');
	loadLanguage('ModSettings');

	require_once($sourcedir . '/ManageMembers.php');
	loadTemplate('BadBehavior_Admin');

	if (empty($_REQUEST['sa']))
		$_REQUEST['sa'] = '';

	$config_vars = array(
	);

	if ($return_config)
		return $config_vars;

	$context['page_title'] = $txt['badbehavior_config'];
	$context['sub_template'] = 'show_settings';
	$context['settings_message'] = BadBehavior_inspect_system();

	$subActions = array(
		'badbehavior_settings' => 'badbehavior_admin_settings',
		'report_all' => 'badbehavior_admin_reports',
		'report_permit' => 'badbehavior_admin_reports',
		'report_denied' => 'badbehavior_admin_reports',
		'bbabout' => 'badbehavior_admin_about',
	);

	// By default go to the settings.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'badbehavior_settings';
	$context['sub_action'] = $_REQUEST['sa'];

	$context['admin_tabs'] = array(
		'title' => &$txt['badbehavior_admin'],
		'description' => $txt['badbehavior_admin_desc'],
		'tabs' => array(
			'badbehavior_settings' => array(
				'title' => $txt['badbehavior_settings_title'],
				'description' => $txt['badbehavior_settings_desc'],
				'href' => $scripturl . '?action=badbehavior;sa=settings;sesc=' . $context['session_id'],
				'is_selected' => $_REQUEST['sa'] == 'badbehavior_settings',
			),
			'report_all' => array(
				'title' => $txt['badbehavior_report_all_title'],
				'description' => $txt['badbehavior_reports_desc'],
				'href' => $scripturl . '?action=badbehavior;sa=report_all;sesc=' . $context['session_id'],
				'is_selected' => $_REQUEST['sa'] == 'report_all',
			),
			'report_permit' => array(
				'title' => $txt['badbehavior_report_permit_title'],
				'description' => $txt['badbehavior_reports_desc'],
				'href' => $scripturl . '?action=badbehavior;sa=report_permit;sesc=' . $context['session_id'],
				'is_selected' => $_REQUEST['sa'] == 'report_permit',
			),
			'report_denied' => array(
				'title' => $txt['badbehavior_report_denied_title'],
				'description' => $txt['badbehavior_reports_desc'],
				'href' => $scripturl . '?action=badbehavior;sa=report_denied;sesc=' . $context['session_id'],
				'is_selected' => $_REQUEST['sa'] == 'report_denied',
			),
			'about' => array(
				'title' => $txt['badbehavior_about_title'],
				'description' => $txt['badbehavior_about_desc'],
				'href' => $scripturl . '?action=badbehavior;sa=bbabout;sesc=' . $context['session_id'],
				'is_selected' => $_REQUEST['sa'] == 'bbabout',
				'is_last' => true,
			),
		),
	);

	// Select the right tab based on the sub action.
	if (isset($context['admin_tabs']['tabs'][$context['sub_action']]))
		$context['admin_tabs']['tabs'][$context['sub_action']]['is_selected'] = true;

	// Call the function for the sub-acton.
	$subActions[$_REQUEST['sa']]();
}

function badbehavior_admin_settings($return_config = false)
{
	isAllowedTo('admin_forum');
	global $txt, $scripturl, $context, $sourcedir, $modSettings, $db_prefix, $settings, $sc;

	require_once($sourcedir.'/ManageServer.php');

	loadLanguage('BadBehavior');

	$config_vars = array(
		array('check', 'enable_badbehavior'),
	    '',
		$txt['badbehavior_stats_title'],
	    '',
		array('check', 'badbehavior_display_stats'),
	    '',
		$txt['badbehavior_logging_title'],
	    '',
		array('check', 'badbehavior_verbose'),
		array('check', 'badbehavior_logging'),
	    '',
		$txt['badbehavior_security'],
	    '',
		array('check', 'badbehavior_strict'),
		array('check', 'badbehavior_offsite_forms'),
		array('check', 'badbehavior_eu_cookie'),
 		'',
		$txt['badbehavior_httpbl'],
	    '',
		array('text', 'badbehavior_httpbl_key', '14'),
		array('text', 'badbehavior_httpbl_threat','4'),
		array('text', 'badbehavior_httpbl_maxage','4'),
		array('large_text', 'badbehavior_httpbl_link'),
		array('text', 'badbehavior_httpbl_word'),
	    '',
		$txt['badbehavior_reverse_load'],
	    '',
		array('check', 'badbehavior_reverse_proxy'),
		array('text', 'badbehavior_reverse_proxy_header', '25'),
		array('large_text', 'badbehavior_reverse_proxy_addresses'),
		'',
		$txt['badbehavior_whitelist_title'],
	    '',
		array('large_text', 'badbehavior_ip'),
		array('large_text', 'badbehavior_url'),
		array('large_text', 'badbehavior_useragent'),
	    '',
		$txt['badbehavior_ooptions'],
	    '',
		array('check', 'badbehavior_limitfirst'),
		array('check', 'badbehavior_email_allow'),
		array('check', 'badbehavior_roundtripdns'),
		array('int', 'badbehavior_cache_duration', '2', 'badbehavior_cache_duration'),
		array('check', 'badbehavior_block_ua'),
		array('select', 'badbehavior_log_timeformat', array(&$txt['badbehavior_log_24_hour_0'], &$txt['badbehavior_log_12_hour_1'])),
		);

	if ($return_config)
		return $config_vars;


	if (isset($_GET['save']))
	{
		checkSession();
		saveDBSettings($config_vars);
		if (!function_exists('bb2_read_settings'))
			require_once($sourcedir . '/bad-behavior/BadBehavior-SMF.php');
		$badbehavior_settings = bb2_read_settings();
		redirectexit('action=badbehavior;sa=settings');
	}

	$context['post_url'] = $scripturl .'?action=badbehavior;save;sa=settings';
	$context['page_title'] = $context['settings_title'] = $txt['badbehavior_settings_sub'];

	prepareDBSettingContext($config_vars);
}

function badbehavior_admin_about()
{
	isAllowedTo('admin_forum');
	global $txt, $context;

	$context['sub_template'] = 'badbehavior_about';
	$context['page_title'] = $txt['badbehavior_about_title'];

}

function badbehavior_admin_reports()
{
	isAllowedTo('admin_forum');
	global $db_prefix, $context, $txt, $page_num, $scripturl;

	if (empty($_REQUEST['bbid']))
		$_REQUEST['bbid'] = '';

	$context['bbid'] = $_REQUEST['bbid'];

	if ($context['bbid'] != '') {
		badbehavior_event();

	} else {
	$sort_columns = array(
		'date' => 'date',
		'request_uri' => 'request_uri',
		'key' => 'key',
	);

	$page_num = 0;
	$per_page = 30;

	if ($context['sub_action'] == 'report_permit')
		$where = "bb.key = '00000000'";
	if ($context['sub_action'] == 'report_denied')
		$where = "bb.key NOT LIKE '00000000'";
	if ($context['sub_action'] == 'report_all')
		$where = "bb.id >= 0";

	$_REQUEST['start'] = empty($_REQUEST['start']) || $_REQUEST['start'] < 0 ? 0 : (int) $_REQUEST['start'];

	if (empty($_REQUEST['sort_by']) || !isset($sort_columns[$_REQUEST['sort_by']])) {
		$_REQUEST['sort_by'] = 'date';
		$_REQUEST['desc'] = true; }

	$context['order_by'] = isset($_REQUEST['desc']) ? 'down' : 'up';
	$context['sort_by'] = $_REQUEST['sort_by'];

	$context['start'] = $_REQUEST['start'];

	$sort_by = $sort_columns[$context['sort_by']];
	$order_by = (isset($_REQUEST['desc']) ? ' desc' : 'asc');

	if (isset($_POST['bb_delall']))	badbehavior_truncate_DB();

	$result = bb2_db_manage($where, $page_num, $per_page, $sort_by, $order_by);

	$context['page_index'] = constructPageIndex($scripturl . '?action=badbehavior;sa='.$context['sub_action'].';sort_by=' . $context['sort_by']. ($context['order_by'] == 'down' ? ';desc' : ''), $_REQUEST['start'], $context['bb2_per_page'], $per_page);

	$page_num = $result[3];

	$context['sub_template'] = 'badbehavior_reports';
	}

	$context['description'] = $txt['badbehavior_reports_desc'];

	if ($context['sub_action'] == 'report_permit')
		$context['settings_title'] = $txt['badbehavior_report_permit_title'];
	if ($context['sub_action'] == 'report_denied')
		$context['settings_title'] = $txt['badbehavior_report_denied_title'];
	if ($context['sub_action'] == 'report_all')
		$context['settings_title'] = $txt['badbehavior_report_all_title'];
}

function bb2_db_manage($where = "bb.id >= 0", $page_num=1, $per_page=5, $sort_by='date', $order_by='desc') {

	isAllowedTo('admin_forum');
	global $db_prefix, $context;

	$limit_start = $orderby = $limit = '';
	$empty_flag = true;
	$context['badbehavior_log'] = array();
	
	if ($page_num < 1) {
		$page_num = 1; }
	if ($per_page < 1) {
		$per_page = 1; }
  if ($sort_by !== 'date' && $sort_by !== 'request_uri' && $sort_by !== 'key') {
		$sort_by='date'; }
	if ($order_by !== 'asc' && $order_by !== 'desc') {
		$order_by='desc'; }

	$qresult = db_query("
		SELECT id
		FROM {$db_prefix}log_badbehavior
		WHERE id >= 0
		", __FILE__, __LINE__);

	if (mysql_num_rows($qresult) == 0)
			$empty_flag = false;

	mysql_free_result($qresult);

	if ($empty_flag === false) {
			$context['badbehavior_log'] = null;
			$total_count = 0;
	} else {
		$total_result = db_query("
			SELECT COUNT(*)
			FROM {$db_prefix}log_badbehavior AS bb
			WHERE " . $where, __FILE__, __LINE__);

		list ($total_count) = mysql_fetch_row($total_result);
		mysql_free_result($total_result);
	}

	$limit_start = (isset($context['start'])? $context['start'] : ($limit_start = ($page_num * $per_page) - $per_page));
	if ($limit_start > $total_count) {
		$limit_start = $total_count-1; }

	if ($per_page > $total_count) {
		$per_page = $total_count; }
	
	$limit_end = $limit_start + $per_page;
	
	if ($limit_end > $total_count) {
		$limit_end = $total_count; }

	//Make sure the page number requested actually exists
	for ($i=$page_num; $i>1; $i--) {
		if ( ( ($page_num * $per_page) - $per_page) > $total_count) {
			$page_num--; } }

	if ($empty_flag !== false) {
		$orderby = "ORDER BY `".$sort_by."` ".$order_by." ";
		$limit = "LIMIT ".$limit_start.", ".$per_page;

		$qresult = db_query("
			SELECT *
			FROM {$db_prefix}log_badbehavior AS bb
			WHERE " . $where . "
			$orderby 
			$limit", __FILE__, __LINE__);

		while($row = mysql_fetch_assoc($qresult)) {

			//This field can be blank alot, so put a space in it.
			if (empty($row['request_entity']))
				$row['request_entity'] = '&nbsp;';

			//  Load DB into array
			$context['badbehavior_log'][] = array(
				'bbid'  => $row['id'],
				'ip'  => $row['ip'],
				'date'  => badbehavior_convertdate($row['date']),
				'request_uri'  => $row['request_uri'],
				'key'  => $row['key'],
			);
		}
	
		mysql_free_result($qresult);
	}

    $limit_start++;	

	$context['bb2_where'] = $limit_start;
	$context['bb2_page_num'] = $limit_end;
	$context['bb2_per_page'] = $total_count;

	$return_array = array($limit_start, $limit_end, $total_count, $page_num);

return $return_array;
}

function badbehavior_event()
{
	isAllowedTo('admin_forum');
	global $sourcedir, $context, $db_prefix, $language;

	$type = $where = $httpbl = '';
	$response = array();

	$context['bbid'] = $_REQUEST['bbid'];

	$qresult = db_query("
		SELECT *
		FROM {$db_prefix}log_badbehavior
		WHERE id = ".$context['bbid']."", __FILE__, __LINE__);

	$row = mysql_fetch_assoc($qresult);

		$context['badbehavior_log'][] = array(
			'bbid'  => $row['id'],
			'ip'  => (empty($row['ip']) ? '' : $row['ip']),
			'date'  => badbehavior_convertdate($row['date']),
			'request_method'  => rawurlencode($row['request_method']),
			'request_uri'  => $row['request_uri'],
			'server_protocol'  => $row['server_protocol'],
			'http_headers'  => htmlspecialchars($row['http_headers']),
			'user_agent'  => rawurlencode($row['user_agent']),
			'request_entity'  => htmlspecialchars($row['request_entity']),
			'key'  => $row['key'],
		);
	if (!function_exists('bb2_get_response')) {
		if (!defined('BB2_CORE')) define('BB2_CORE', dirname(__FILE__));
		if (file_exists($sourcedir . '/bad-behavior/bad-behavior/responses.inc.' . $language . '.php'))
			require_once($sourcedir . '/bad-behavior/bad-behavior/responses.inc.' . $language . '.php');
		else
			require_once($sourcedir . '/bad-behavior/bad-behavior/responses.inc.php');
	}
	$response = bb2_get_response($row['key']);
	if (!empty($response['log'])) {
		$context['log'] = $response['log'];
		$context['explanation'] = $response['explanation'].(($row['key'] == '2b021b1f') ? "<br />".bb2_httpbl_lookup($row["ip"]) : "");
		$context['response'] = $response['response'];
	} else {
		$context['log'] = $context['explanation'] = $context['response'] = '';
	}

	unset($response);
	mysql_free_result($qresult);

	$context['sub_template'] = 'badbehavior_event';
}

//  Must be forced on via db edit
function bb2_httpbl_lookup($ip) {
	isAllowedTo('admin_forum');

	global $txt;
	// NB: Many of these are defunct

	$bb_settings = bb2_read_settings();
	$httpbl_key = $bb_settings['httpbl_key'];
	if (!isset($httpbl_key) || empty($httpbl_key)) return false;

	$engines = array(
		0 => $txt['badbehavior_engines0'],
		1 => $txt['badbehavior_engines1'],
		2 => $txt['badbehavior_engines2'],
		3 => $txt['badbehavior_engines3'],
		4 => $txt['badbehavior_engines4'],
		5 => $txt['badbehavior_engines5'],
		6 => $txt['badbehavior_engines6'],
		7 => $txt['badbehavior_engines7'],
		8 => $txt['badbehavior_engines8'],
		9 => $txt['badbehavior_engines9'],
		10 => $txt['badbehavior_engines10'],
		11 => $txt['badbehavior_engines11'],
		12 => $txt['badbehavior_engines12'],
	);

	$r = (isset($_SESSION['badbehavior_httpbl'][$ip]) ? $_SESSION['badbehavior_httpbl'][$ip] : "");
	$d = "";
	if (!$r) {	// Lookup
		$find = implode('.', array_reverse(explode('.', $ip)));
		$result = gethostbynamel("${httpbl_key}.${find}.dnsbl.httpbl.org.");
		if (!empty($result)) {
			$r = $result[0];
			$_SESSION['badbehavior_httpbl'][$ip] = $r;
		}
	}
	if ($r) {	// Interpret
		$ip = explode('.', $r);
		if ($ip[0] == 127) {
			if ($ip[3] == 0) {
				if ($engines[$ip[2]]) {
					$d .= $engines[$ip[2]];
				} else {
					$d .= $txt['badbehavior_search_engine']."${ip[2]}<br />";
				}
			}
			if ($ip[3] & 1) {
				$d .= $txt['badbehavior_suspicious']."<br />";
			}
			if ($ip[3] & 2) {
				$d .= $txt['badbehavior_harvester']."<br />";
			}
			if ($ip[3] & 4) {
				$d .= $txt['badbehavior_comment_spammer']."<br />";
			}
			if ($ip[3] & 7) {
				$d .= $txt['badbehavior_threat_level']."${ip[2]}<br />";
			}
			if ($ip[3] > 0) {
				$d .= $txt['badbehavior_age']."${ip[1]}".$txt['badbehavior_days']."<br />";
			}
		}
	}
	return $d;
}
function BadBehavior_inspect_system() {
	isAllowedTo('admin_forum');
	global $modSettings, $txt, $language, $sourcedir;

	$string = '';

	if ($_SERVER['HTTP_USER_AGENT'] == "Bad Behavior Test") {
			$string =  $txt['badbehavior_17f4e8c8'];
	} else {
		$string = bb2_insert_stats(true);
	}

	if (!$modSettings['enable_badbehavior']) return $string;

	if (loadlanguage('BadBehavior') === false)
		loadlanguage('BadBehavior');

	if (!file_exists($sourcedir . '/BadBehavior-mysql.php') || !file_exists($sourcedir . '/bad-behavior/BadBehavior-SMF.php') || !file_exists($sourcedir . '/bad-behavior/bad-behavior/core.inc.php')) {
		$string =$string.'<br /><div class="meaction">' . $txt['badbehavior_incorrect'] . '</div><br />';
		$modSettings['enable_badbehavior'] = '0';
		return $string;
	}
	if (!empty($modSettings['badbehavior_httpbl_key']) && (preg_match('/[^a-z]/', $modSettings['badbehavior_httpbl_key']) || strlen($modSettings['badbehavior_httpbl_key']) != 12)) {
		$string =$string.'<br /><div class="meaction">' . $txt['badbehavior_httpBL_api'] . '</div><br />';
		return $string;
	}
	if (!empty($modSettings['badbehavior_httpbl_threat']) && ((!is_numeric($modSettings['badbehavior_httpbl_threat'])) || ((int) $modSettings['badbehavior_httpbl_threat'] < 0) || ((int) $modSettings['badbehavior_httpbl_threat'] >= 256))) {
		$string =$string.'<br /><div class="meaction">' . $txt['badbehavior_httpBL_threat'] . '</div><br />';
		return $string;
  }
	if (!empty($modSettings['badbehavior_httpbl_maxage']) && ((!is_numeric($modSettings['badbehavior_httpbl_maxage'])) || ((int) $modSettings['badbehavior_httpbl_maxage'] <= 0) || ((int) $modSettings['badbehavior_httpbl_maxage'] >= 61))) {
		$string =$string.'<br /><div class="meaction">' . $txt['badbehavior_httpBL_maxage'] . '</div><br />';
		return $string;
  }
	if (!empty($modSettings['badbehavior_httpbl_link']) && ((substr($modSettings['badbehavior_httpbl_link'], 0, 7) != 'http://') && (substr($modSettings['badbehavior_httpbl_link'], 0, 8) != 'https://'))) {
		$string =$string.'<br /><div class="meaction">' . $txt['badbehavior_httpBL_link'] . '</div><br />';
		return $string;
	}
	if (!empty($modSettings['badbehavior_httpbl_word']) && (!preg_match('/^[a-zA-Z0-9 -]+$/', $modSettings['badbehavior_httpbl_word']))) {
		$string =$string.'<br /><div class="meaction">' . $txt['badbehavior_httpBL_word'] . '</div><br />';
		return $string;
	}

	if (!function_exists('badbehavior_checkCache'))
		require_once($sourcedir . '/bad-behavior/BadBehavior-SMF.php');

	if (((int) $modSettings['badbehavior_cache_duration']) != 0) {
		$ip2 = 'httpBL_status';
		$cache_flag = false;
		require_once($sourcedir . '/Load.php');
		$cache_flag = badbehavior_checkCache($ip2);
		$result = array();

		if ($cache_flag) {
			$cache_content = $stamp = $bb_salt = '';
			$result = array();
			$stamp = date('Ymd');
			$bb_salt = 'J#c3';
		if (function_exists('hash')) {
			if ($stamp  % 2) {
				$badbehavior_algo = 'tiger160,4';
			} else {
				$badbehavior_algo = 'haval192,4'; }
			$cache_content = badbehavior_cache_get_data('badbehavior-' . substr(hash($badbehavior_algo,$bb_salt.$stamp.$ip2), -8), 0);
		} else { 
			$cache_content = badbehavior_cache_get_data('badbehavior-' . substr(md5($bb_salt.$stamp.$ip2), -8), 0); }
			$result[0] = ($cache_content == "false" ? "false" : $cache_content);
			unset($cache_content,$stamp,$bb_salt);
		} }

	if (empty($result)) {
		$lookup = array();
		$lookup['types'] = bb2_httpbl_lookup('127.1.1.5');
		$lookup['threat'] = bb2_httpbl_lookup('127.1.80.1');
		$lookup['days'] = bb2_httpbl_lookup('127.80.1.1');

		if (empty($lookup['types']) || empty($lookup['threat']) || empty($lookup['days']) ) {
			$result[0] = "false";
		} else {
			$result = $lookup['threat'];
		}
		unset($lookup);
	}

	if (((int) $modSettings['badbehavior_cache_duration']) != 0) {
		$badbehavior_cache_array = array();
		$badbehavior_cache_array[0] = ($result ? $result[0]: "false");
		badbehavior_loadCache($ip2, $badbehavior_cache_array);
		unset($badbehavior_cache_array);
	}

	if ($result[0] == "false") {
		$string =$string.'<br /><div class="meaction">' . $txt['badbehavior_httpBL_offline'] . '</div><br />';
	} else {
		$string =$string.'<br /><div style="color:green;">' . $txt['badbehavior_httpBL_online'] . '</div><br />';
	}
	unset($result);
	unset($ip2);
	return $string;
}
// Converts dates in log screen output to 12 hr format
function badbehavior_convertdate($bbdate) {
	isAllowedTo('admin_forum');
	global $modSettings;
  
	switch ((int) $modSettings['badbehavior_log_timeformat']) {
	case 0:
		return $bbdate;
	break;
	case 1:
		return date('Y-m-d g:i:s A', strtotime($bbdate));
	break;
	default:
		return $bbdate;
	break; }
}
function badbehavior_truncate_DB() {
	if (!function_exists('isAllowedTo')) return;
	isAllowedTo('admin_forum');
	global $db_prefix;

	db_query("
			TRUNCATE {$db_prefix}log_badbehavior", __FILE__, __LINE__);
}
?>