<?php
/**********************************************************************************
* BadBehavior-mysql.php  - for SMF 1.1.x - PHP database interface for Bad Behavior mod
* Version 1.5.17 by JMiller a/k/a butchs
* (http://www.eastcoastrollingthunder.com) 
*********************************************************************************
* This program is distributed in the hope that it is and will be useful, but
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
**********************************************************************************/

if (!defined('SMF')) die('Hacking attempt...');

global $txt, $modSettings, $db_prefix, $smcFunc, $sourcedir;

require_once($sourcedir . '/bad-behavior/BadBehavior-SMF.php');

// Our log table structure
function bb2_table_structure($name) {
global $txt, $modSettings, $db_prefix;

	return db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}log_badbehavior", __FILE__, __LINE__);
}

// Create a new table for SMF 2.0 RC2
function bb2_insert_table() {

	global $txt, $user_info, $db_prefix;

	//  check for old database
	$query_old_table = db_query("SHOW TABLES 
		LIKE '{$db_prefix}log_badbehavior'
		",__FILE__,__LINE__);

	$old_table_exists = mysql_num_rows($query_old_table);
	mysql_free_result($query_old_table);

	//  add new database
	if (!$old_table_exists) {
		db_query("CREATE TABLE IF NOT EXISTS
			{$db_prefix}log_badbehavior (
			`id` INT(11) NOT NULL auto_increment,
			`ip` varchar(16) NOT NULL,
			`date` varchar(19) NOT NULL default '0000-00-00 00:00:00',
			`request_method` varchar(4) NOT NULL,
			`request_uri` varchar(255) NOT NULL,
			`server_protocol` varchar(15) NOT NULL,
			`http_headers` text NOT NULL default '',
			`user_agent` varchar(255) NOT NULL,
			`request_entity` varchar(255) NOT NULL,
			`key` varchar(255) NOT NULL,
			INDEX (`ip`(15)),
			INDEX (`user_agent`(10)),
			PRIMARY KEY (`id`)
		)", __FILE__, __LINE__);
	}
}

// Insert a new record modified for SMF 1.1.x
function bb2_insert($bb2_settings, $package, $key)
{
	global $txt, $modSettings, $db_prefix;

	if (empty($package)) return '';
	if (!is_array($package)) return '';
	if (!$bb2_settings['logging']) return '';

	$request = $ip = $date = $request_method = $request_entity = '';
	$request_uri = $server_protocol = $user_agent = $http_headers = '';

	$ip = bb2_db_escape($package['ip']);
	$date = bb2_db_date();
	$request_method = bb2_db_escape($package['request_method']);
	$request_uri = bb2_db_escape($package['request_uri']);
	$server_protocol = bb2_db_escape($package['server_protocol']);
	$user_agent = bb2_db_escape($package['user_agent']);
	$http_headers = "$request_method $request_uri $server_protocol\n\r";
	foreach ($package['headers'] as $h => $v) {
		$http_headers .=  $h . ": " .$v . "\n\r";
	}
	$http_headers = bb2_db_escape($http_headers);
	unset($v);

	if (!strcasecmp($request_method, "POST")  && (!empty($package['request_entity']))) {
		foreach ($package['request_entity'] as $h => $v) {
			$request_entity .= $h . ": " .$v . "\n\r";
		}
	$request_entity = bb2_db_escape($request_entity);
	unset($v);
	}

	return "INSERT IGNORE INTO
	{$db_prefix}log_badbehavior
		(`ip`, `date`, `request_method`, `request_uri`, `server_protocol`, `http_headers`, `user_agent`, `request_entity`, `key`) VALUES
		('$ip', '$date', '$request_method', '$request_uri', '$server_protocol', '$http_headers', '$user_agent', '$request_entity', '$key')";
}

?>
