<?php if (!defined('BB2_CWD')) die("I said no cheating!");
define('BB2_VERSION', "2.2.20");

// Bad Behavior entry point is bb2_start()
// If you're reading this, you are probably lost.
// Go read the bad-behavior-generic.php file.

define('BB2_CORE', dirname(__FILE__));
define('BB2_COOKIE', 'bb2_screener_');

require_once(BB2_CORE . "/functions.inc.php");

// Kill 'em all!
function bb2_banned($bb_settings, $package, $key, $previous_key=false)
{
	// Some spambots hit too hard. Slow them down a bit.
	sleep(2);

	// Bad Behavior for SMF start
	global $language;
	if (file_exists(BB2_CORE . '/banned.inc.' . $language . '.php'))
		require_once(BB2_CORE . '/banned.inc.' . $language . '.php');
	else
		require_once(BB2_CORE . '/banned.inc.php');
	// Bad Behavior for SMF end
	bb2_display_denial($bb_settings, $package, $key, $previous_key);
	bb2_log_denial($bb_settings, $package, $key, $previous_key);
	if (is_callable('bb2_banned_callback')) {
		bb2_banned_callback($bb_settings, $package, $key);
	}
	// Penalize the spammers some more
	bb2_housekeeping($bb_settings, $package);
	die();
}

function bb2_approved($bb_settings, $package)
{
	// Dirk wanted this
	if (is_callable('bb2_approved_callback')) {
		bb2_approved_callback($bb_settings, $package);
	}

	// Decide what to log on approved requests.
	if (($bb_settings['verbose'] && $bb_settings['logging']) || empty($package['user_agent'])) {
		global $user_info;
		$user_info['is_suspicious'] = 1;
		bb2_db_query(bb2_insert($bb_settings, $package, "00000000"));
	}
}

# If this is reverse-proxied or load balanced, obtain the actual client IP
function bb2_reverse_proxy($bb_settings, $headers_mixed)
{
	# If this is a bot scan return false
	if (empty($bb_settings)) return false;

	# Define to remove errors on forced bot scans
	$addrs = false;
	$header = '';

	# Detect if option is on when it should be off
	$header = uc_all($bb_settings['reverse_proxy_header']);

	#  isset is faster
	if ((isset($headers_mixed[$header])) || (!empty($headers_mixed[$header])) || (array_key_exists($header, $headers_mixed))) {
		$addrs = $headers_mixed[$header];
	} else {
		return $addrs;
	}

	# Define to remove errors on forced bot scans
	$addr = '';
	$addrs_array = array();
	if (!empty($addrs)) {
		$addrs_array = @array_reverse(preg_split("/[\s,]+/", $addrs));
	}

	# Skip our known reverse proxies and private addresses only if array exists
	if (isset($bb_settings['reverse_proxy_addresses']) && !empty($bb_settings['reverse_proxy_addresses']) && !empty($addrs_array)) {
		foreach ($addrs_array as $addr) {
			if (!match_cidr($addr, $bb_settings['reverse_proxy_addresses']) && !is_rfc1918($addr)) {
				$addrs = $addr;
				break;
			}
		}
	} elseif (!empty($addrs_array)) {
		foreach ($addrs_array as $addr) {
			if (!is_rfc1918($addr)) {
				$addrs = $addr;
				break;
			}
		}
	}
	unset($addr);
	unset($addrs_array);
	return $addrs;
}


# FIXME: Bug #12. But this code doesn't currently work.
function bb2_unpack_php_post_array($key, $value)
{
	$unpacked = array();
	foreach ($value as $k => $v) {
		$i = $key. '[' . $k . ']';
		if (is_array($v))
			$v = bb2_unpack_php_post_array($i, $v);
		$unpacked[$i] = $v;
	}
	return $unpacked;
}

// Let God sort 'em out!
function bb2_start($bb_settings)
{
	// Gather up all the information we need, first of all.
	$headers = bb2_load_headers();
	// Postprocess the headers to mixed-case
	// TODO: get the world to stop using PHP as CGI
	$headers_mixed = array();
	foreach ($headers as $h => $v) {
		$headers_mixed[uc_all($h)] = $v;
	}

	// IPv6 - IPv4 compatibility mode hack
	$_SERVER['REMOTE_ADDR'] = preg_replace("/^::ffff:/", "", $_SERVER['REMOTE_ADDR']);

	// Reconstruct the HTTP entity, if present.
	$request_entity = array();
	if (isset($_SERVER['REQUEST_METHOD']) && (!strcasecmp($_SERVER['REQUEST_METHOD'], "POST") || !strcasecmp($_SERVER['REQUEST_METHOD'], "PUT"))) {
		foreach ($_POST as $h => $v) {
			if (is_array($v)) {
				# Workaround, see Bug #12
				$v = "Array";
			}
			$request_entity[$h] = $v;
		}
	}

	$request_uri = $_SERVER["REQUEST_URI"];
	if (!$request_uri) $request_uri = $_SERVER['SCRIPT_NAME'];	# IIS

	if ($bb_settings['reverse_proxy'] && $ip = bb2_reverse_proxy($bb_settings, $headers_mixed)) {
		$headers['X-Bad-Behavior-Remote-Address'] = $_SERVER['REMOTE_ADDR'];
		$headers_mixed['X-Bad-Behavior-Remote-Address'] = $_SERVER['REMOTE_ADDR'];
	} else {
		$ip = $_SERVER['REMOTE_ADDR'];
	}

	@$package = array('ip' => $ip, 'headers' => $headers, 'headers_mixed' => $headers_mixed, 'request_method' => $_SERVER['REQUEST_METHOD'], 'request_uri' => $request_uri, 'server_protocol' => $_SERVER['SERVER_PROTOCOL'], 'request_entity' => $request_entity, 'user_agent' => $_SERVER['HTTP_USER_AGENT'], 'is_browser' => false, 'is_suspicious' => false,);

	// Bad Behavior for SMF start
	global $txt, $modSettings, $sourcedir;

	if (!function_exists('badbehavior_checkCache'))
		require_once($sourcedir . '/bad-behavior/BadBehavior-SMF.php');

	if (((int) $modSettings['badbehavior_cache_duration']) != 0) {
		$ip2 = '';
		$cache_flag = false;
		$ip2 = $package['ip'];
		require_once($sourcedir . '/Load.php');
		$cache_flag = badbehavior_checkCache($ip2);

		if ($cache_flag) {
			$cache_content = $result = $stamp = $bb_salt = '';
			$stamp = date('Ymd');
			$bb_salt = 'K4$c';
		if (function_exists('hash')) {
			if ($stamp  % 2) {
				$badbehavior_algo = 'tiger160,4';
			} else {
				$badbehavior_algo = 'haval192,4'; }
			$cache_content = badbehavior_cache_get_data('badbehavior-' . substr(hash($badbehavior_algo,$bb_salt.$stamp.$ip2), -8), 0);
		} else { 
			$cache_content = badbehavior_cache_get_data('badbehavior-' . substr(md5($bb_salt.$stamp.$ip2), -8), 0); }

			$result = ($cache_content == "false" ? false : $cache_content);
			unset($cache_content,$stamp,$bb_salt);
		if ($result) bb2_banned($bb_settings, $package, $result);
	return $result; } }

	$result = bb2_screen($bb_settings, $package);

	if (((int) $modSettings['badbehavior_cache_duration']) != 0) {
		$badbehavior_cache_array = array();
		$badbehavior_cache_array[0] = ($result ? $result : "false");
		badbehavior_loadCache($ip2, $badbehavior_cache_array);
		unset($badbehavior_cache_array);
	}
	if ($result && !defined('BB2_TEST')) bb2_banned($bb_settings, $package, $result);
		return $result;
	// Bad Behavior for SMF end
}

function bb2_screen($bb_settings, $package)
{
	// Please proceed to the security checkpoint, have your identification
	// and boarding pass ready, and prepare to be nakedized or fondled.

	// CloudFlare-specific checks not handled by reverse proxy code
	// Thanks to butchs at Simple Machines
	/* if (array_key_exists('Cf-Connecting-Ip', $package['headers_mixed'])) {
		require_once(BB2_CORE . "/cloudflare.inc.php");
		$r = bb2_cloudflare($package);
		if ($r !== false && $r != $package['ip']) return $r;
	} */

	// First check the whitelist
	require_once(BB2_CORE . "/whitelist.inc.php");
	if (!bb2_run_whitelist($package)) {
		// Now check the blacklist
		require_once(BB2_CORE . "/blacklist.inc.php");
		if ($r = bb2_blacklist($package)) return $r;

		// Check the http:BL
		require_once(BB2_CORE . "/blackhole.inc.php");
		if ($r = bb2_httpbl($bb_settings, $package)) {
			if ($r == 1) return false;	# whitelisted
			if ($r == 3) {
				$package['is_suspicious'] = true;
				$r = false;
			} else {
				return $r;
		}	}

		// Check for common stuff
		require_once(BB2_CORE . "/common_tests.inc.php");
		if ($r = bb2_protocol($bb_settings, $package)) return $r;
		if ($r = bb2_cookies($bb_settings, $package)) return $r;
		if ($r = bb2_misc_headers($bb_settings, $package)) return $r;

		// Specific checks
		@$ua = $package['user_agent'];
		// Search engine checks come first
		if (stripos($ua, "bingbot") !== FALSE || stripos($ua, "Adidxbot") !== FALSE || stripos($ua, "MSNBot") !== FALSE || stripos($ua, "BingPreview") !== FALSE) {
			require_once(BB2_CORE . "/searchengine.inc.php");
			if ($r = bb2_msnbot($package)) {
				if ($r == 1) return false;	# whitelisted
				return $r;
			}
			return false;
		} elseif (stripos($ua, "Googlebot") !== FALSE || stripos($ua, "Mediapartners-Google") !== FALSE || stripos($ua, "Google Web Preview") !== FALSE || stripos($ua, "AdsBot-Google") !== FALSE) {
			require_once(BB2_CORE . "/searchengine.inc.php");
			if ($r = bb2_google($package)) {
				if ($r == 1) return false;	# whitelisted
				return $r;
			}
			return false;
		} elseif (stripos($ua, "Yahoo! Slurp") !== FALSE || stripos($ua, "Yahoo!-AdCrawler") !== FALSE || stripos($ua, "Yahoo! SearchMonkey") !== FALSE || stripos($ua, "YahooSeeker") !== FALSE) {
			require_once(BB2_CORE . "/searchengine.inc.php");
			if ($r = bb2_yahoo($package)) {
				if ($r == 1) return false;	# whitelisted
				return $r;
			}
			return false;
		} elseif (stripos($ua, "Baidu") !== FALSE) {
			require_once(BB2_CORE . "/searchengine.inc.php");
			if ($r = bb2_baidu($package)) {
				if ($r == 1) return false;	# whitelisted
				return $r;
			}
			return false;
		}
		// MSIE checks
		if (stripos($ua, "; MSIE") !== FALSE) {
			$package['is_browser'] = true;
			require_once(BB2_CORE . "/browser.inc.php");
			if (stripos($ua, "Opera") !== FALSE) {
				if ($r = bb2_opera($package)) return $r;
			} else {
				if ($r = bb2_msie($package)) return $r;
			}
		} elseif (stripos($ua, "Konqueror") !== FALSE) {
			$package['is_browser'] = true;
			require_once(BB2_CORE . "/browser.inc.php");
			if ($r = bb2_konqueror($package)) return $r;
		} elseif (stripos($ua, "Opera") !== FALSE) {
			$package['is_browser'] = true;
			require_once(BB2_CORE . "/browser.inc.php");
			if ($r = bb2_opera($package)) return $r;
		} elseif (stripos($ua, "Safari") !== FALSE) {
			$package['is_browser'] = true;
			require_once(BB2_CORE . "/browser.inc.php");
			if ($r = bb2_safari($package)) return $r;
		} elseif (stripos($ua, "Lynx") !== FALSE) {
			$package['is_browser'] = true;
			require_once(BB2_CORE . "/browser.inc.php");
			if ($r = bb2_lynx($package)) return $r;
		} elseif (stripos($ua, "MovableType") !== FALSE) {
			require_once(BB2_CORE . "/movabletype.inc.php");
			if ($r = bb2_movabletype($package)) return $r;
		} elseif (stripos($ua, "Mozilla") !== FALSE && stripos($ua, "Mozilla") == 0) {
			$package['is_browser'] = true;
			require_once(BB2_CORE . "/browser.inc.php");
			if ($r = bb2_mozilla($package)) return $r;
		}

		// More intensive screening applies to POST requests
		if (!strcasecmp('POST', $package['request_method'])) {
			require_once(BB2_CORE . "/post.inc.php");
			if ($r = bb2_post($bb_settings, $package)) return $r;
		}
	}

	global $modSettings;
	if ($modSettings['badbehavior_block_ua']) {
		if (empty($package['user_agent'])) {
			bb2_banned($bb_settings, $package, "SMF11111");
	}	}
	// Last chance screening.
	require_once(BB2_CORE . "/screener.inc.php");
	bb2_screener($bb_settings, $package);

	// And that's about it.
	bb2_approved($bb_settings, $package);
	if ($package['is_suspicious']) {
		global $user_info;
		$user_info['is_suspicious'] = 1;
		bb2_db_query(bb2_insert($bb_settings, $package, "00000000")); }
	return false;
}
?>