<?php if (!defined('BB2_CORE')) die('I said no cheating!');

// Defines the responses which Bad Behavior might return.

function bb2_get_response($key) {
	$bb2_responses = array(
		'00000000' => array('response' => 200, 'explanation' => '', 'log' => 'Permitido'),
		'SMF11111' => array('response' => 403, 'explanation' => 'Debe tener un Agente de Usuario (User Agent) para acceder a este sitio.', 'log' => 'Agente de Usuario (User Agent) necesario no aparece'),
		'136673cd' => array('response' => 403, 'explanation' => 'Su direcci&oacute;n IP se encuentra en una lista negra de direcciones involucradas en actividades ilegales o malintencionadas. Consulte la lista a continuaci&oacute;n para obtener m&aacute;s informaci&oacute;n sobre listas espec&iacute;ficas y los procedimientos para su eliminaci&oacute;n.', 'log' => 'Direcci&oacute;n IP encontrada en lista negra externa'),
		'17566707' => array('response' => 403, 'explanation' => 'Se recibi&oacute; una petici&oacute;n no v&aacute;lida desde su navegador. Esto puede deberse a un mal funcionamiento del servidor proxy o a la configuraci&oacute;n de privacidad del navegador.', 'log' => 'Header necesario \'Aceppt\' no presente'),
		'17f4e8c8' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor.', 'log' => 'User-Agent encontrado en lista negra'),
		'21f11d3f' => array('response' => 403, 'explanation' => 'Se recibi&oacute; una petici&oacute;n no v&aacute;lida. Afirma ser un dispositivo Web m&oacute;vil, pero en realidad no lo parece.', 'log' => 'User-Agent afirma ser AvantGo, pero la afirmaci&oacute;n parece ser falsa'),
		'2b021b1f' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor. Antes de volver a intentarlo, ejecute el software anti-virus y anti-spyware para eliminar cualquier virus y spyware de su equipo.', 'log' => 'Direcci&oacute;n IP encontrada en lista negra de http:BL'),
		'2b90f772' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor. Si est&aacute; usando el navegador Opera, entonces Opera debe aparecer como User-Agent.', 'log' => 'Conexi&oacute;n: TE presente, no soportado por MSIE'),
		'35ea7ffa' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor. Compruebe el idioma y configuraci&oacute;n regional de su navegador.', 'log' => 'Idioma especificado no es v&aacute;lido'),
		'408d7e72' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor. Antes de volver a intentarlo, ejecute el software anti-virus y anti-spyware para eliminar cualquier virus y spyware de su ordenador.', 'log' => 'POST sucede a GET con demasiada rapidez'),
		'41feed15' => array('response' => 400, 'explanation' => 'Se recibi&oacute; una petici&oacute;n no v&aacute;lida. Puede deberse a un funcionamiento incorrecto del servidor proxy. Omita el proxy y con&eacute;ctese directamente, o contacte con el administrador del servidor proxy.', 'log' => 'Header \'Pragma\' sin \'Cache-Control\' prohibido en peticiones HTTP/1.1'),
		'45b35e30' => array('response' => 400, 'explanation' => 'Se recibi&oacute; una petici&oacute;n no v&aacute;lida desde su navegador. Esto puede deberse a un mal funcionamiento del servidor proxy o a la configuraci&oacute;n de privacidad del navegador.', 'log' => 'Header \'Referer\' est&aacute; corrupto'),
		'57796684' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor. Antes de volver a intentarlo, ejecute el software anti-virus y anti-spyware para eliminar cualquier virus y spyware de su ordenador.', 'log' => 'Header prohibido \'X-Aaaaaaaaaa\' o \'X-Aaaaaaaaaaaa\' presente'),
		'582ec5e4' => array('response' => 400, 'explanation' => 'Se recibi&oacute; una petici&oacute;n no v&aacute;lida. Si est&aacute; usando un servidor proxy, omita el proxy o contacte con el administrador de su servidor proxy. Esto puede causarlo tambi&eacute;n un bug del navegador Opera.', 'log' => '"Header \'TE\' presente pero TE no especificado en \'Connection\' header'),
		'69920ee5' => array('response' => 400, 'explanation' => 'Se recibi&oacute; una petici&oacute;n no v&aacute;lida desde su navegador. Esto puede deberse a un mal funcionamiento del servidor proxy o a la configuraci&oacute;n de privacidad del navegador.', 'log' => 'Header \'Referer\' presente pero en blanco'),
		'6c502ff1' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor.', 'log' => 'Bot no es del todo compatible con RFC 2965'),
		'70e45496' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor.', 'log' => 'User-Agent afirma ser CloudFlare, pero la afirmaci&oacute;n parece ser falsa'),
		'71436a15' => array('response' => 403, 'explanation' => 'Se recibi&oacute; una petici&oacute;n no v&aacute;lida. Afirma ser un destacado motor de b&uacute;squeda, pero no parece ser tal cosa.', 'log' => 'User-Agent afirma ser Yahoo, pero la afirmaci&oacute;n parece ser falsa'),
		'799165c2' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor.', 'log' => 'Detectada renovaci&oacute;n de User-Agent'),
		'7a06532b' => array('response' => 400, 'explanation' => 'Se recibi&oacute; una petici&oacute;n no v&aacute;lida desde su navegador. Esto puede deberse a un mal funcionamiento del servidor proxy o a la configuraci&oacute;n de privacidad del navegador.', 'log' => 'Header necesario \'Accept-Encoding\' no aparece'),
		'7ad04a8a' => array('response' => 400, 'explanation' => 'El programa que est&aacute; usando no tiene permiso para acceder a este servidor. Por favor use un programa diferente o un navegador Web est&aacute;ndar.', 'log' => 'Header prohibido \'Range\' presente'),
		'7d12528e' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor.', 'log' => 'Header prohibido \'Range\' o \'Content-Range\' en petici&oacute;n POST'),
		'939a6fbb' => array('response' => 403, 'explanation' => 'El servidor proxy que est&aacute; usando no tiene permiso para acceder a este servidor. Por favor omita el proxy o contacte con el administrador de su servidor proxy.', 'log' => 'Servidor proxy prohibido en uso'),
		'96c0bd29' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor.', 'log' => 'URL elementos encontrado en lista negra'),
		'9c9e4979' => array('response' => 403, 'explanation' => 'El servidor proxy que est&aacute; usando no tiene permiso para acceder a este servidor. Por favor omita el proxy o contacte con el administrador de su servidor proxy.', 'log' => 'Header prohibido \'via\' presente'),
		'a0105122' => array('response' => 417, 'explanation' => 'Error en Expect. Por favor vuelva a intentar su petici&oacute;n.', 'log' => 'Header \'Expect\' prohibido; reenv&iacute;ar sin Expect'),
		'a1084bad' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor.', 'log' => 'User-Agent afirma ser MSIE, con una versi&oacute;n no v&aacute;lida de Windows'),
		'a52f0448' => array('response' => 400, 'explanation' => 'Se recibi&oacute; una petici&oacute;n no v&aacute;lida.  Esto puede deberse a un mal funcionamiento del servidor proxy o a la configuraci&oacute;n de privacidad del navegador. Si est&aacute; usando un servidor proxy, omita el proxy o contacte con el administrador de su servidor proxy.', 'log' => 'Header \'Connection\' contiene valores no v&aacute;lidos'),
		'b0924802' => array('response' => 400, 'explanation' => 'Se recibi&oacute; una petici&oacute;n no v&aacute;lida. Puede deberse a la existencia de software malicioso en su ordenador.', 'log' => 'Formato incorrecto de HTTP/1.0 Keep-Alive'),
		'b40c8ddc' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor. Antes de volver a intentarlo, cierre su navegador, y ejecute el software anti-virus y anti-spyware para eliminar cualquier virus y spyware de su ordenador.', 'log' => 'POST con m&aacute;s de dos d&iacute;as despu&eacute;s de GET'),
		'b7830251' => array('response' => 400, 'explanation' => 'Su servidor proxy envi&oacute; una petici&oacute;n no v&aacute;lida. Por favor contacte con el administrador de su servidor proxy para solucionar este problema.', 'log' => 'Header prohibido \'Proxy-Connection\' presente'),
		'b9cc1d86' => array('response' => 403, 'explanation' => 'El servidor proxy que est&aacute; usando no tiene permiso para acceder a este servidor. Por favor omita el proxy o contacte con el administrador de su servidor proxy.', 'log' => 'Header prohibido \'X-Aaaaaaaaaa\' o \'X-Aaaaaaaaaaaa\' presente'),
		'c1fa729b' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor. Antes de volver a intentarlo, ejecute el software anti-virus y anti-spyware para eliminar cualquier virus y spyware de su ordenador.', 'log' => 'Uso de rotaci&oacute;n en servidores proxy detectada.'),
		'cd361abb' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor. No pueden publicarse datos desde formularios externos.', 'log' => 'Referer no apunta a un formulario en este sitio'),
		'd60b87c7' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor. Antes de volver a intentarlo, por favor elimine cualquier virus o spyware presente en su ordenador.', 'log' => 'Trackback recibido v&iacute;a servidor proxy'),
		'dfd9b1ad' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor.', 'log' => 'La solicitud contiene JavaScript malicioso o ataque de inyecci&oacute;n SQL'),
		'e3990b47' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor. Antes de volver a intentarlo, por favor elimine cualquier virus o spyware presente en su ordenador.', 'log' => 'Falso trackback recibido'),
		'e4de0453' => array('response' => 403, 'explanation' => 'Se recibi&oacute; una petici&oacute;n no v&aacute;lida. Afirma ser un destacado motor de b&uacute;squeda, pero no parece ser tal cosa.', 'log' => 'User-Agent afirma ser msnbot, pero la afirmaci&oacute;n parece ser falsa'),
		'e87553e1' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor.', 'log' => 'Te conozco y no soy c&oacute;mo t&uacute;, sucio spammer.'),
		'f0dcb3fd' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor. Antes de volver a intentarlo, ejecute el software anti-virus y anti-spyware para eliminar cualquier virus y spyware de su ordenador.', 'log' => 'Navegador Web ha intentado enviar un trackback'),
		'f1182195' => array('response' => 403, 'explanation' => 'Se recibi&oacute; una petici&oacute;n no v&aacute;lida. Afirma ser un destacado motor de b&uacute;squeda, pero no parece ser tal cosa.', 'log' => 'User-Agent afirma ser Googlebot, pero la afirmaci&oacute;n parece ser falsa.'),
		'f9f2b8b9' => array('response' => 403, 'explanation' => 'No tiene permiso para acceder a este servidor. Esto puede deberse a un mal funcionamiento del servidor proxy o a la configuraci&oacute;n de privacidad del navegador.', 'log' => 'Se requiere un User-Agent pero no se proporcion&oacute; ninguno.'),
	);

	if (array_key_exists($key, $bb2_responses)) return $bb2_responses[$key];
	return array('00000000');
}
?>