<?php if (!defined('BB2_CORE')) die('I said no cheating!');

require_once(BB2_CORE . "/roundtripdns.inc.php");

// Analyze user agents claiming to be Googlebot

function bb2_google($package)
{
	if (@is_ipv6($package['ip'])) return false;	# TODO
	if (match_cidr($package['ip'], array("64.18.0.0/20", "66.102.0.0/20", "64.233.160.0/19", "66.249.80.0/20", "72.14.192.0/18", "74.125.0.0/16", "173.194.0.0/16", "203.208.32.0/19", "207.126.144.0/20", "209.85.128.0/17", "216.239.32.0/19")) === FALSE) {
		return false;	# Soft fail, must pass other screening
		#return "f1182195";	# Hard fail
	}
	if (!bb2_roundtripdns($package['ip'], "googlebot.com")) {
		return false;
	}
	return 1;	# Real Googlebot; bypass all other checks
}

// Analyze user agents claiming to be msnbot

function bb2_msnbot($package)
{
	if (@is_ipv6($package['ip'])) return false;	# TODO
	if (match_cidr($package['ip'], array("64.4.0.0/18", "65.52.0.0/16", "131.253.21.0/24", "131.253.22.0/23", "131.253.24.0/21", "131.253.32.0/20", "40.76.0.0/14", "157.54.0.0/15", "157.56.0.0/14", "157.60.0.0/16", "199.30.16.0/20", "207.46.0.0/16", "207.68.128.0/18", "207.68.192.0/20")) === FALSE) {
		return false;	# Soft fail, must pass other screening
		#return "e4de0453";	# Hard fail
	}
	if (!bb2_roundtripdns($package['ip'], "search.msn.com")) {
		return false;
	}
	return 1;	# Real msnbot; bypass all other checks
}

// Analyze user agents claiming to be Yahoo!

function bb2_yahoo($package)
{
	if (@is_ipv6($package['ip'])) return false;	# TODO
	if (match_cidr($package['ip'], array("8.12.144.0/24", "66.196.64.0/18", "66.228.160.0/19", "67.195.0.0/16", "68.142.192.0/18", "69.147.64.0/18", "72.30.0.0/16", "74.6.0.0/16", "98.136.0.0/14", "114.111.64.0/18", "124.83.128.0/17", "183.79.0.0/16", "202.160.176.0/20", "209.191.64.0/18", "216.109.112.0/20")) === FALSE) {
		return false;	# Soft fail, must pass other screening
		#return '71436a15';	# Hard fail
	}
	if (!bb2_roundtripdns($package['ip'], "crawl.yahoo.net") || !bb2_roundtripdns($package['ip'], "yahoo.com") || !bb2_roundtripdns($package['ip'], "yse.yahoo.net")) {
		return false;
	}
	return 1;	# Real Yahoo bot; bypass all other checks
}

// Analyze user agents claiming to be Baidu

function bb2_baidu($package)
{
	if (@is_ipv6($package['ip'])) return false;	# TODO
	if (match_cidr($package['ip'], array("119.63.192.0/21", "123.125.71.0/24", "180.76.0.0/16", "185.10.104.0/22", "220.181.0.0/16")) === FALSE) {
		return false;	# Soft fail, must pass other screening
	}
	if ((!bb2_roundtripdns($package['ip'], ".baidu.com")) || (!bb2_roundtripdns($package['ip'], ".baidu.jp"))) {
		return false;
	}
	return 1;	# Real Baidu bot; bypass all other checks
}
?>