<?php
/**********************************************************************************
* install_db.php - Search for & install database log, scheduled task & modsettings
* Version 1.5.18 by JMiller a/k/a butchs
* (http://www.eastcoastrollingthunder.com) 
*********************************************************************************
* This program is distributed in the hope that it is and will be useful, but
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
**********************************************************************************/

// If SSI.php is in the same place as this file, and SMF isn't defined, this is being run standalone.
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
{
	require_once(dirname(__FILE__) . '/SSI.php');
}

// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF')) exit('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

global $smcFunc, $sourcedir, $boarddir, $language, $user_info, $db_prefix, $ssi_theme, $settings;

if ((SMF == 'SSI') && !$user_info['is_admin']) die('Admin priveleges required.');


if(isset($smcFunc)) {

	if (function_exists('db_extend')) {
		db_extend('packages');
		db_extend();
	} else {
		require_once($sourcedir . '/Subs-Db-mysql.php');
		db_extend('packages');
		db_extend(); }

//  remove old verision modsettings
if ((isset($modSettings['badbehavior_log_table']))) {
	$smcFunc['db_query']('', '
		DELETE FROM {db_prefix}settings WHERE variable = "badbehavior_log_table"
	');
}

//  Add scheduled task
$query = $smcFunc['db_query']('', '
	SELECT id_task FROM {db_prefix}scheduled_tasks WHERE task = "badbehavior"
');

if ($smcFunc['db_num_rows']($query) == 0)
	$smcFunc['db_query']('', '
		INSERT INTO {db_prefix}scheduled_tasks (id_task, next_time, time_offset, time_regularity, time_unit, disabled, task)
		VALUES (NULL, 0, 0, 1, "d", 0, "badbehavior")'
	);

$query = $smcFunc['db_query']('', '
	SELECT id_task FROM {db_prefix}scheduled_tasks WHERE task = "prgbadbehavior"
');

if ($smcFunc['db_num_rows']($query) == 0)
	$smcFunc['db_query']('', '
		INSERT INTO {db_prefix}scheduled_tasks (id_task, next_time, time_offset, time_regularity, time_unit, disabled, task)
		VALUES (NULL, 0, 0, 1, "d", 0, "prgbadbehavior")'
	);


	//  add bbc
	if (function_exists('add_integration_function')) {
	$badbehavior_integraton_hooks = array(
		'integrate_bbc_codes' => 'badbehavior_suspicious_hide',
		'integrate_bbc_buttons' => 'badbehavior_suspicious_button',
		'integrate_pre_include' => '$boarddir/Sources/Subs_badbehavior_bbc.php',
	);

	foreach ($badbehavior_integraton_hooks as $badbehavior_hook => $badbehavior_integraton_function)
		add_integration_function($badbehavior_hook, $badbehavior_integraton_function, TRUE);

	Unset($badbehavior_integraton_hooks);
	Unset($badbehavior_hook, $badbehavior_integraton_function);
	}

	$badbehavior_ip = '';
	$badbehavior_ip = "64.191.203.34\n208.67.217.130\n";

// add mod settings
	$smcFunc['db_insert']('ignore',
		$db_prefix . 'settings',
			array('variable' => 'string', 'value' => 'string',
			),
			array(
				array('enable_badbehavior', '0'),
				array('badbehavior_display_stats', '0'),
				array('badbehavior_strict', '0'),
				array('badbehavior_verbose', '0'),
				array('badbehavior_logging', '1'),
				array('badbehavior_httpbl_key', ''),
				array('badbehavior_httpbl_threat', '25'),  //  changed 1.4.0
				array('badbehavior_httpbl_maxage', '30'),
				array('badbehavior_httpbl_link', ''),
				array('badbehavior_httpbl_word', ''),
				array('badbehavior_offsite_forms', '0'),
				array('badbehavior_eu_cookie', '0'),
				array('badbehavior_reverse_proxy', '0'),   //  new 1.4.0
				array('badbehavior_reverse_proxy_header', 'X-Forwarded-For'),  //  new 1.4.0
				array('badbehavior_reverse_proxy_addresses', ''),  //  new 1.4.0
				array('badbehavior_limitfirst', '0'),  //  new 1.5.3
				array('badbehavior_email_allow', '0'),
				array('badbehavior_roundtripdns', '0'),
				array('badbehavior_timelimit', '7'),
				array('badbehavior_cache_duration', '8'),
				array('badbehavior_block_ua', '0'),
				array('badbehavior_log_timeformat', '0'),  //  new 1.5.4
				array('badbehavior_ip', $badbehavior_ip),  //  new 1.5.10
				array('badbehavior_url', ''),  //  new 1.5.10
				array('badbehavior_useragent', ''),  //  new 1.5.10
			),
			array('variable')
		);

//  check for old database
	$old_table_exists = $smcFunc['db_list_tables'](false, $db_prefix . 'log_badbehavior');

//  add new database
if (empty($old_table_exists)) {
	$smcFunc['db_create_table']($db_prefix.'log_badbehavior',
			array(
				array(
					'name' => 'id',
					'type' => 'int',
					'size' => 11,
					'null' => false,
					'default' => '',
					'auto' => true,
					'unsigned' => true,
				),
				array(
					'name' => 'ip',
					'type' => 'varchar',
					'size' => 16,
					'null' => false,
					'default' => '',
					'auto' => false,
					'unsigned' => false,
				),
				array(
					'name' => 'date',
					'type' => 'varchar',
					'size' => 19,
					'null' => false,
					'default' => '0000-00-00 00:00:00',
					'auto' => false,
					'unsigned' => false,
				),
				array(
					'name' => 'request_method',
					'type' => 'varchar',
					'size' => 4,
					'null' => false,
					'default' => '',
					'auto' => false,
					'unsigned' => false,
				),
				array(
					'name' => 'request_uri',
					'type' => 'varchar',
					'size' => 255,
					'null' => false,
					'default' => '',
					'auto' => false,
					'unsigned' => false,
				),
				array(
					'name' => 'server_protocol',
					'type' => 'varchar',
					'size' => 15,
					'null' => false,
					'default' => '',
					'auto' => false,
					'unsigned' => false,
				),
				array(
					'name' => 'http_headers',
					'type' => 'text',
					'size' => '',
					'null' => false,
					'auto' => false,
					'unsigned' => false,
				),
				array(
					'name' => 'user_agent',
					'type' => 'varchar',
					'size' => 255,
					'null' => false,
					'default' => '',
					'auto' => false,
					'unsigned' => false,
				),
				array(
					'name' => 'request_entity',
					'type' => 'varchar',
					'size' => 255,
					'null' => false,
					'default' => '',
					'auto' => false,
					'unsigned' => false,
				),
				array(
					'name' => 'key',
					'type' => 'varchar',
					'size' => 255,
					'null' => false,
					'default' => '',
					'auto' => false,
					'unsigned' => false,
				),
			),
			array( 
				array(
					'type' => 'primary',
					'columns' => array('id')
				),
				array(
					'type' => 'index',
					'columns' => array('ip'),
					'size' => 15,
				),
				array(
					'type' => 'index',
					'columns' => array('user_agent'),
					'size' => 10,
				)
			),
			'ignore'
	);
	} else {  //  Upgrade from old version
			// Change headers
			$smcFunc['db_change_column']($db_prefix . 'log_badbehavior', 'http_headers',
				array(
					'name' => 'http_headers',
					'type' => 'text',
				),
				array(
					'no_prefix' => true,
				)
			);
			// Second time to make sure
			$smcFunc['db_change_column']($db_prefix . 'log_badbehavior', 'http_headers',
				array(
					'name' => 'http_headers',
					'type' => 'text',
				),
				array(
					'no_prefix' => true,
				)
			);
			// Change date
			$smcFunc['db_change_column']($db_prefix . 'log_badbehavior', 'date',
				array(
					'name' => 'date',
					'size' => 19,
				),
				array(
					'no_prefix' => true,
				)
			);
}

} else {

	if ((isset($modSettings['badbehavior_log_table']))) {
	db_query("DELETE FROM {$db_prefix}settings 
            WHERE variable = 'badbehavior_log_table'", __FILE__, __LINE__);
	}

	$badbehavior_ip = '';
	$badbehavior_ip = "64.191.203.34\n208.67.217.130\n";

	db_query("INSERT IGNORE INTO
		{$db_prefix}settings
			(variable, value)
		VALUES	('enable_badbehavior', '0'),
				('badbehavior_display_stats', '0'),
				('badbehavior_strict', '0'),
				('badbehavior_verbose', '0'),
				('badbehavior_logging', '1'),
				('badbehavior_httpbl_key', ''),
				('badbehavior_httpbl_threat', '25'),
				('badbehavior_httpbl_maxage', '30'),
				('badbehavior_httpbl_link', ''),
				('badbehavior_httpbl_word', ''),
				('badbehavior_offsite_forms', '0'),
				('badbehavior_eu_cookie', '0'),
				('badbehavior_reverse_proxy', '0'),
				('badbehavior_reverse_proxy_header', 'X_FORWARDED_FOR'),
				('badbehavior_reverse_proxy_addresses', ''),
				('badbehavior_limitfirst', '0'),
				('badbehavior_email_allow', '0'),
				('badbehavior_roundtripdns', '0'),
				('badbehavior_timelimit', '7'),
				('badbehavior_cache_duration', '8'),
				('badbehavior_block_ua', '0'),
				('badbehavior_log_timeformat', '0'),
				('badbehavior_ip', '$badbehavior_ip'),
				('badbehavior_url', ''),
				('badbehavior_useragent', '')
			", __FILE__, __LINE__);

	//  check for old database
	$query_old_table = db_query("SHOW TABLES 
		LIKE '{$db_prefix}log_badbehavior'
		",__FILE__,__LINE__);

	$old_table_exists = mysql_num_rows($query_old_table);
	mysql_free_result($query_old_table);

	//  add new database
	if (!$old_table_exists) {
		db_query("CREATE TABLE IF NOT EXISTS
			{$db_prefix}log_badbehavior (
			`id` INT(11) NOT NULL auto_increment,
			`ip` varchar(16) NOT NULL,
			`date` varchar(19) NOT NULL default '0000-00-00 00:00:00',
			`request_method` varchar(4) NOT NULL,
			`request_uri` varchar(255) NOT NULL,
			`server_protocol` varchar(15) NOT NULL,
			`http_headers` text NOT NULL,
			`user_agent` varchar(255) NOT NULL,
			`request_entity` varchar(255) NOT NULL,
			`key` varchar(255) NOT NULL,
			INDEX (`ip`(15)),
			INDEX (`user_agent`(10)),
			PRIMARY KEY (`id`)
		)", __FILE__, __LINE__);
	}

	//  Try to make bbcache directory writable
	if (function_exists('chmod')) {
		@chmod($boarddir.'/bbcache', 0755);

		if (substr(__FILE__, 1, 2) != ':\\') {  //  Linux
			if (!is_writable($boarddir.'/bbcache') && !@chmod($boarddir.'/bbcache', 0755))
				@chmod($boarddir.'/bbcache', 0777);
		} else {   //  Windows
			@chmod($boarddir.'/bbcache', 0777);
			@chmod($boarddir.'/bbcache/index.php', 0777);
			@chmod($boarddir.'/bbcache/.htaccess', 0777);
	}	}
}
?>